---
title: FileSystemDirectoryEntry.getFile()
slug: Web/API/FileSystemDirectoryEntry/getFile
tags:
  - API
  - File System API
  - File and Directory Entries API
  - FileSystemDirectoryEntry
  - Files
  - Method
  - Non-standard
  - Reference
  - getFile
---
<p>{{APIRef("File System API")}}{{SeeCompatTable}}</p>

<p>The {{domxref("FileSystemDirectoryEntry")}} interface's method <code><strong>getFile</strong></code><strong><code>()</code></strong> returns a {{domxref("FileSystemFileEntry")}} object corresponding to a file contained somewhere within the directory subtree rooted at the directory on which it's called.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><em>FileSystemDirectoryEntry</em>.getFile([<em>path</em>][, <em>options</em>][, <em>successCallback</em>][, <em>errorCallback</em>]);</pre>

<h3 class="syntaxbox" id="Parameters">Parameters</h3>

<dl>
 <dt><code>path</code> {{optional_inline}}</dt>
 <dd>A {{domxref("USVString")}} specifying the path, relative to the directory on which the method is called, describing which file's entry to return.</dd>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An object based on the {{domxref("FileSystemFlags")}} dictionary, which allows you to specify whether or not to create the entry if it's missing and if it's an error if the file already exists. These options are currently not useful in Web contexts.</dd>
 <dt><code>successCallback</code> {{optional_inline}}</dt>
 <dd>A method to be called once the {{domxref("FileSystemFileEntry")}} has been created. The method receives a single parameter: the <code>FileSystemFileEntry</code> object representing the file in question.</dd>
 <dt><code>errorCallback</code> {{optional_inline}}</dt>
 <dd>A method to be called if an error occurs. Receives as its sole input parameter a {{domxref("FileError")}} object describing the error which occurred.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h3 id="Errors">Errors</h3>

<p>If an error occurs and an <code>errorCallback</code> was specified, it gets called with a single parameter: a {{domxref("FileError")}} object describing the error. The {domxref("FileError.code")}} specifies what type of error occurred, as follows:</p>

<dl>
 <dt><code>FileError.NOT_FOUND_ERR</code></dt>
 <dd>The <code>create</code> option was not specified (or was specified as <code>false</code>), and the file doesn't exist.</dd>
 <dt><code>FileError.PATH_EXISTS_ERR</code></dt>
 <dd>The <code>create</code> and <code>exclusive</code> options were both <code>true</code>, indicating that the file should be created but must not already exist, but the file does in fact already exist.</dd>
 <dt><code>FileError.SECURITY_ERR</code></dt>
 <dd>The request to access the file was denied for security reasons.</dd>
 <dt><code>FileError.TYPE_MISMATCH_ERR</code></dt>
 <dd>The path specified is not a file; it's probably a directory, but might be an unsupported file descriptor such as a pipe; this depends on the user agent to some extent.</dd>
</dl>

<h2 id="FileSystemFlags">FileSystemFlags</h2>

<p>The <code>options</code> parameter is an object which is based on the {{domxref("FileSystemFlags")}} dictionary; it provides flags which make it possible to adjust the behavior of the <code>getFile()</code> method.</p>

<p>{{page("/en-US/docs/Web/API/FileSystemFlags", "Properties")}}</p>

<h2 id="Example">Example</h2>

<p>In this example, a function is presented whose job it is to locate within a user's app data directory a JSON file containing a user dictionary for a specified language, then load that dictionary.</p>

<pre class="brush: js notranslate">let dictionary = null;

function loadDictionaryForLanguage(appDataDirEntry, lang) {
  dictionary = null;

  appDataDirEntry.getDirectory("Dictionaries", {}, function(dirEntry) {
    dirEntry.getFile(lang + "-dict.json", {}, function(fileEntry) {
      fileEntry.file(function(dictFile) {
        let reader = new FileReader();

        reader.addEventListener("loadend", function() {
          dictionary = JSON.parse(reader.result);
        });

        reader.readAsText(dictFile);
      });
    });
  });
}
</pre>

<p>The <code>loadDictionaryForLanguage()</code> function starts by using <code>getDirectory()</code> to obtain the {{domxref("FileSystemDirectoryEntry")}} object representing a subfolder named "Dictionaries" located inside the specified app data directory. The success callback for this takes the resulting directory entry object and calls {{domxref("FileSystemDirectoryEntry.getFile", "getFile()")}} to get a {{domxref("FileSystemFileEntry")}} object representing the dictionary file; the success callback for this, in turn, creates a new {{domxref("FileReader")}} and uses it to load the contents of the file. When that is loaded successfully (as indicated by the {{event("loadend")}} event being fired), the loaded text is passed into {{jsxref("JSON.parse()")}} to be reconstituted into a JavaScript object.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('File System API', '#dom-filesystemdirectoryentry-getfile', 'getFile()') }}</td>
   <td>{{ Spec2('File System API') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("api.FileSystemDirectoryEntry.getFile")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
 <li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
 <li>{{domxref("FileSystemFileEntry")}}</li>
</ul>
